<?php
//
// +---------------------------------------------------------------------------+
// | PHPDump Plugin 1.0 for Geeklog - The Ultimate Weblog                      |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the phpdump    |
// | PHP files.                                                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Oliver Spiesshofer          -    oliver@spiesshofer.com                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


/**
* Language file Include
*/

$langfile = $_CONF['path'] . 'plugins/phpdump/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile))
{
    include_once ($langfile);
}
else
{
    include_once ($_CONF['path'] . 'plugins/phpdump/language/english.php');
}

function plg_phpdump_dobackup()
    {
    require("phpmysqldump.php");
    global $_CONF, $_DB_host, $_DB_user, $_DB_pass, $_DB_name;
    $sav = new phpmysqldump( $_DB_host, $_DB_user, $_DB_pass, $_DB_name, "en", $link);
    $sav->sousdir=$_CONF['backup_path'];
    $sav->fly=0;                    //  not use drive send the dump directly to the browser
    $sav->compress_ok=$_POST['compress'];           //  flag to activate compression

    //Added by mthomas@shindengen.com 12/2/04
    $sav->configpath=$_CONF['path'];
    $sav->htmlpath=$_CONF['path_html'];
    $sav->compress_wdir=$_POST['compresswdir'];
    //End add
    
    $sav->backup();                    //  launch the back up
    # $sav->compress();             // optional - compress to the gz format without using the shell
    # $sav->nettoyage();                //  optional  erase the old back up files   
    return plg_phpdump_showbackups();
    
    }

function plg_phpdump_showbackups()
    {
    # derived from database.php
    global $_CONF, $LANG_DB_BACKUP, $LANG24;
    if(is_writable($_CONF['backup_path']))
        {
        $backups = array();
        $display .= COM_startBlock ($LANG_DB_BACKUP['last_ten_backups'], '', COM_getBlockTemplate ('_admin_block', 'header'));
        $fd = opendir($_CONF['backup_path']);
        $index = 0;
        while ((false !== ($file = @readdir ($fd)))) {
            if ($file <> '.' && $file <> '..' && $file <> 'CVS' &&
                    preg_match ('/\.sql$/i', $file)) {
                $index++;
                clearstatcache();
                $backups[] = $file;
            }
            elseif ($file <> '.' && $file <> '..' && $file <> 'CVS' &&
                    preg_match ('/\.sql.gz$/i', $file)) {
                $index++;
                clearstatcache();
                $backups[] = $file;
            }
            //Added by mthomas@shindengen.com 12/2/04
            elseif ($file <> '.' && $file <> '..' && $file <> 'CVS' && 
                    preg_match ('/\.tgz$/i', $file)) {
                $index++;
                clearstatcache();
                $backups[] = $file;
            }
            //End Add
        }
        if (is_array($backups) AND $index > 0) {
            krsort($backups);
            $backups = array_slice ($backups, 0, 10);
            reset($backups);

            $database = new Template ($_CONF['path_layout'] . 'admin/database');
            $database->set_file (array ('list' => 'listbackups.thtml',
                                        'row' => 'listitem.thtml'));
            $database->set_var ('site_url', $_CONF['site_url']);
            $database->set_var ('layout_url', $_CONF['layout_url']);
            $database->set_var ('lang_backupfile', $LANG_DB_BACKUP['backup_file']);
            $database->set_var ('lang_backupsize', $LANG_DB_BACKUP['size']);
            $database->set_var ('lang_bytes', $LANG_DB_BACKUP['bytes']);

            for ($i = 1; $i <= count ($backups); $i++) {
                $backupfile = $_CONF['backup_path'] . current ($backups);
                $backupfilesize = filesize ($backupfile);
                $database->set_var ('backup_file', current ($backups));
                $database->set_var ('backup_size', $backupfilesize);
                $database->parse ('backup_item', 'row', true);
                next($backups);
            }
            $database->set_var ('number_backups',
                    sprintf ($LANG_DB_BACKUP['total_number'], $index));
            $display .= $database->parse ('output', 'list');
        } else {
            $display .= '<p>' . $LANG_DB_BACKUP['no_backups'] . '</p>';
        }

        // Show backup form
        $display .= $LANG_DB_BACKUP['db_explanation'];

       $display.="<FORM action='./index.php' method='POST'>
       <input type='hidden' name='plg_phpdump_action' value='plg_phpdump_dobackup'>
       GZip? {$LANG24[35]}<INPUT TYPE='RADIO'  name='compress' value='1' checked> {$LANG24[36]} <INPUT TYPE='RADIO'  name='compress' value='0'><br>
       <br>Include Commonly Altered Files and Directories?<br>
       <table border=1 cellpadding=2><tr>
       <td><b>Files</b></td><td><b>Directories</b><br>(Sub-directories Included)</td>
       <td rowspan=2>{$LANG24[35]}<INPUT TYPE='CHECKBOX'  name='compresswdir' value='1'></td></tr>
       <tr>
       <td>
       	config.php<br>
       	lib-common.php<br>
       </td>
       <td>
		[geeklog_base_dir]/plugins<br>
		[geeklog_public_dir]/admin/plugins<br>
		[geeklog_public_dir]/layout<br>
		[geeklog_public_dir]/images<br>
	   </td>
	   </tr></table>
	    
       <br>
       <BR><INPUT TYPE='SUBMIT' VALUE='{$LANG_DB_BACKUP['do_backup']}'>
       </form>";

        $display .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
    } else {
        $display .= COM_startBlock ($LANG08[06], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $LANG_DB_BACKUP['no_access'];
        COM_errorLog ($_CONF['backup_path'] . ' is not accessible.', 1);
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    }
    return $display;
    }

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
*
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_phpdump()
{
    $menuitems = array();
    return $menuitems;
}

/**
* Check to see if this Plugin uses comments
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_phpdump()
{
    return false;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* Universal Plugin:  Modify/uncomment use it
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_phpdump($showsitestats)
{
//    global $_CONF, $_TABLES;
    $retval='';
    return $retval;
}

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* Add the plugin name, icon and link to the command and control block in moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_phpdump()
{
    global $_CONF;
    return "";
}

/**
* Returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* Universal Plugin:  Modify/Uncomment use it
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_phpdump()
{
    global $_CONF, $_TABLES;

    if (SEC_hasRights('phpdump.admin')) {
        return array('DB Backup w.php', $_CONF['site_admin_url'] . '/plugins/phpdump/index.php', "N/A");
    }
}

/**
* Returns the user option for this plugin
*
* Adds the plugin to the user menu
*
* Universal Plugin:  modify/uncomment use it
*
* @return   array   Array containing (plugin name, plugin user url, 0)
*
*/
function plugin_getuseroption_phpdump()
{

}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_phpdump($installCheck='')
{
    global $_TABLES, $LANG_phpDump00;

    // The phpdumps need to be changed to the name of your plugin
    //
    $pi_name='phpdump';
    $FEATURES = array ('phpdump.admin');
    $TABLES = array ();
    
    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
	    COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
		$display .= COM_startBlock($LANG_phpDump00['warning']);
		$display .= $LANG_phpDump00['enabled'];
		$display .= COM_endBlock();
		echo $display;
		return false;
		exit;
	}
    	
	// Ok to proceed and delete plugin

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the phpdump plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'phpdump'",1);

    // Drop phpdump tables
    foreach($TABLES as $table) {
        $t = $_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    // Remove Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_gid'");
    
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_gid'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
    
    // Remove all the associated features -- access rights
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }
        
    COM_errorLog('...success',1);
    return true;
}
?>